.MODEL TINY
.386
.CODE

.STARTUP
jmp Start

ZoomAddZahl     equ 100

angle           db 0
ZoomAdd         dd ZoomAddZahl
zoom            dd 8000h

Handle          dw -1

BufSeg          dw -1       ; for being changed
PalSeg          dw -1

FileName        db "rotator.pcx",0
Error           db "Fehler!",13,10,"$"
MyName          db "MO by GG",13,10,"(C) Georg Lukas",9,9,"georg@boerde.de",13,10,"$"

;Palette         db 768 dup (0)
include sinus.inc
;Header          db 128 dup (0)

@Error:
                mov     ax,cs
                mov     ds,ax
                mov     dx,offset Error
                mov     ah,9h
                int     21h
                mov     ax,4C00h
                int     21h

OpenFile proc
                ; Datei ffnen
                mov     ax,3D20h
                mov     dx,offset FileName
                int     21h
                jc @Error
                mov     Handle,ax
                ret
OpenFile endp


ByteBuf         db 0

getByte proc
                push    cx
                push    dx
                mov     ah,3Fh
                mov     dx,offset ByteBuf
                mov     cx,1
                int     21h
                jc @Error
                mov     al,ByteBuf
                pop     dx
                pop     cx
                ret
getByte endp

LoadData proc
                mov     ax,cs
                add     ax,1000h
                mov     PalSeg,ax
                add     ax,1000h
                mov     bufSeg,ax

                ; Header lesen
                mov     bx,Handle
                mov     ah,3Fh
                mov     cx,128
                mov     dx,768
                mov     ds,PalSeg
                int     21h
                jc @Error
                mov     ax,cs
                mov     ds,ax

                mov     es,BufSeg
                xor     di,di
                mov     bx,Handle
@lpGetData:
                call getByte
                cmp     al,0C0h
                ja @byteFolge
                stosb
@endOfget:
                or      di,di
                jnz @lpGetData

                ret
@byteFolge:
                xor     ch,ch
                sub     al,0C0h
                mov     cl,al
                call getByte
                rep stosb
                jmp @endofget

LoadData endp


InitGraph proc
                ; seek(f, End-768);
                mov     bx,Handle
                mov     ax,4202h
                mov     cx,-1
                mov     dx,-768
                int     21h
                jc @Error
                ; BlockRead(f, Pal);
                mov     ah,3Fh
                xor     dx,dx
                mov     cx,768
                mov     ds,PalSeg
                int     21h
                jc @Error
                mov     ax,cs
                mov     ds,ax

                ; VGA-Test
                mov     ax,1A00h
                int     10h
                cmp     al,1Ah
                jnz @Error
                cmp     bl,7
                jb @Error
                cmp     bl,8
                ja @Error
                ; GrafikModus setzen
                mov     ax,13h
                int     10h

                ; Palette setzen
                mov     es,PalSeg
                xor     si,si
                mov     cx,768
                mov     dx,3C8h
                xor     ax,ax
                out     dx,al
                inc     dx
@PalLoop:
                db 26h                  ; ES-Seg-Prefix
                lodsb
                shr     al,2
                out     dx,al
                loop @PalLoop
                ret
InitGraph endp



;
;
;
;
;
x       dd 0
y       dd 0
retrx   dd 0
retry   dd 0
sin     dd 0
cos     dd 0

showIt proc
                ; sin:=SinS[angle]
                xor     bh,bh
                mov     bl,angle
                shl     bx,1
                mov     si,offset SinS          ; from sinus.inc
                mov     ax,[si+bx]
                cwde
                mov     ebx,10000h
                imul    ebx
                idiv    zoom
                mov     sin,eax
                ; cos:=SinS[angle-90]
                xor     bh,bh
                mov     bl,64
                sub     bl,angle
                shl     bx,1
                mov     si,offset SinS          ; from sinus.inc
                mov     ax,[si+bx]
                cwde
                mov     ebx,10000h
                imul    ebx
                idiv    zoom
                mov     cos,eax

                ; retrx := -320*horx + verx;
                mov     eax,cos
                mov     ebx,-320
                imul    ebx
                sub     eax,sin
                mov     retrx,eax

                ; retry := -320*hory + very;
                mov     eax,sin
                mov     ebx,-320
                imul    ebx
                add     eax,cos
                mov     retry,eax

                ; x := -160*horxstep - 100*verxstep - 128 shl 16;
                mov     eax,cos
                mov     ebx,-160
                imul    ebx
                mov     x,eax
                ;
                mov     eax,sin
                mov     ebx,100
                imul    ebx
                add     x,eax
                ;
                mov     ax,128
                shl     eax,16
                sub     x,eax

                ; y := -160*hory - 100*very - 128 shl 16;
                mov     eax,sin
                mov     ebx,-160
                imul    ebx
                mov     y,eax
                ;
                mov     eax,cos
                mov     ebx,-100
                imul    ebx
                add     y,eax
                ;
                mov     ax,128
                shl     eax,16
                sub     y,eax




                mov     fs,BufSeg
                mov     ax,0A000h
                mov     es,ax
                xor     di,di

                mov     ebx,x           ; x = ebx
                mov     edx,y           ; y = edx
                mov     cx,200
@loopY:
                push    cx
                mov     cx,320
@loopX:
                ; Screen[y, x]:=data[(y sar 16) and $FF, (x sar 16) and $FF];
                mov     eax,ebx
                sar     eax,16
                and     ax,0FFh
                mov     si,ax
                ;
                mov     eax,edx
                sar     eax,16
                shl     ax,8
                add     si,ax

                db      64h             ; fs: seg-prefix
                movsb

                add     ebx,cos
                add     edx,sin

                loop @loopX

                pop     cx

                add     ebx,retrx
                add     edx,retry

                loop @loopY

                ret
showIt endp
;
;
;
;
;

; Retrace: 0=inaktiv 8=aktiv
WaitRetrace proc
                push    dx
                mov     dx,3DAh
@retrOn:
                in      al,dx
                test    al,8
                jne @retrOn
@retrOff:
                in      al,dx
                test    al,8
                je @retrOff
                pop     dx
                ret
WaitRetrace endp





CloseFile proc
                mov     ah,3Eh
                mov     bx,Handle
                int     21h
CloseFile endp

CloseGraph proc
                mov     ax,03h
                int     10h
                ret
CloseGraph endp

@ZoomToBig:
               mov      ZoomAdd,-ZoomAddZahl
               jmp @ZoomChg

@ZoomToSmall:
               mov      ZoomAdd,ZoomAddZahl
               jmp @ZoomChg



Start:
                ; Init
                call OpenFile
                call LoadData
                call InitGraph
                ; Stop Kbd Int
                in      al,21h
                or      al,2
                out     21h,al
                ; Run
@KeyPressed:
                ;call WaitRetrace
                call ShowIt
                inc     angle
                mov     eax,ZoomAdd
                add     Zoom,eax
                cmp     Zoom,10000h
                jg @ZoomToBig
                cmp     Zoom,2000h
                jl @ZoomToSmall
@Zoomchg:
                ;
                in      al,60h
                cmp     al,129
                jnz @KeyPressed

                in      al,21h
                and     al,0FDh
                out     21h,al
                ; Done
                call CloseGraph
                call CloseFile
                ; exit
                mov     ah,09h
                mov     dx,offset MyName
                int     21h
                mov     ax,4C00h
                int     21h


Ende    equ this byte
end